﻿using System;
using System.Xml.Serialization;
using System.Collections.Generic;
using System.IO;
using System.Windows.Forms;

namespace LCDFontMaker
{
    [Serializable]
    public class LanguageFontMaker
    {
        public bool Default { get; set; }
        public string Language { get; set; }
        public string File { get; set; }
        public string Exit { get; set; }
        public string Lang { get; set; }
        public string Help { get; set; }
        public string About { get; set; }
        public string EditFontTable { get; set; }
        public string ImgForOCR { get; set; }
        public string Address { get; set; }
        public string Source { get; set; }
        public string FromOCR { get; set; }
        public string PrefSymbol { get; set; }
        public string UserSymbol { get; set; }
        public string DublAddr { get; set; }
        public string KeybEqual { get; set; }
        public string Save { get; set; }
        public string Name { get; set; }
        public string ButtonSave { get; set; }
        public string OpenFile { get; set; }
        public string SelectPage { get; set; }
        public string PrefOCR { get; set; }
        public string Scale { get; set; }
        public string Proporc { get; set; }
        public string Offset { get; set; }
        public string DotDot { get; set; }
        public string SymbSymb { get; set; }
        public string TriggerCoor { get; set; }
        public string SelUnusedSymb { get; set; }
        public string Error { get; set; }
        public string Attention { get; set; }
        public string Message4 { get; set; }
        public string Message6 { get; set; }
        public string Message8 { get; set; }
        public string Message9 { get; set; }
        public string DialogPdfImageFilter { get; set; }
        public string DialogPdfFilter { get; set; }
        public string DialogFileFilter { get; set; }
        public string DatasheetEmbedded { get; set; }
        public LanguageFontMaker()
        {
            Language = "Русский";
            File = "Файл";
            Exit = "Выход";
            Lang = "Language";
            Help = "Справка";
            About = "О программе";
            EditFontTable = "Правка и настройка таблицы символов";
            ImgForOCR = "Изображение для распознавания";
            Address = "адрес";
            Source = "Источник";
            FromOCR = "из распознавания";
            PrefSymbol = "Настройки символа";
            UserSymbol = "пользовательский символ";
            DublAddr = "дублирование на адрес";
            KeybEqual = "сопоставление клавиатуре";
            Save = "Сохранение";
            Name = "имя";
            ButtonSave = "сохранить";
            OpenFile = "Открыть файл";
            SelectPage = "Выбрать эту страницу";
            PrefOCR = "Настройки распознавания";
            Scale = "Масштаб";
            Proporc = "сохранять пропорции";
            Offset = "смещение";
            DotDot = "точка<->точка";
            SymbSymb = "знак<->знак";
            TriggerCoor = "порог цвета распознавания";
            SelUnusedSymb = "отметить ненужные символы";
            Error = "Ошибка!";
            Attention = "Внимание!";
            Message4 = "Введите наименование.";
            Message6 = "Сохранено.";
            Message8 = "Не удалось открыть файл.";
            Message9 = "Ошибка работы с бинарными данными.";
            DialogPdfImageFilter = "Файлы Adobe PDF|*.pdf|Изображения|*.bmp;*.jpg;*.jpeg;*.png;*.gif|Все файлы|*.*";
            DialogPdfFilter = "Файлы Adobe PDF|*.pdf|Все файлы|*.*";
            DialogFileFilter = "Файлы шрифта LCD|*.lcd|Все файлы|*.*";
            DatasheetEmbedded = "Даташит встроен";
        }
    }

    public static class LanguageFunction
    {
        public static string FileName = string.Empty;
        public static string Default = string.Empty;
        public static LanguageFontMaker Read(string lng)
        {            
            if (Directory.Exists(Application.StartupPath + @"\language"))
            {
                List<string> ty = new List<string>(Directory.GetFiles(Application.StartupPath + @"\language", "*.xml"));
                foreach (string s in ty)
                {
                    try
                    {
                        XmlSerializer ser = new XmlSerializer(typeof(LanguageFontMaker));
                        TextReader reader = new StreamReader(s);
                        LanguageFontMaker Fields = ser.Deserialize(reader) as LanguageFontMaker;
                        reader.Close();
                        if (Fields.Language == lng)
                        {
                         //   FileName = s;
                         //   Fields.PatchHelp = Application.StartupPath + @"\help\" + Path.GetFileNameWithoutExtension(s) + @"\help.rtf";
                            return Fields;
                        }                        
                    }
                    catch
                    {
                        MessageBox.Show("Cannot read file language.", "Error");
                    }
                }
            }            
            return null;
        }
        public static List<string> GetList()
        {
            List<string> result = new List<string>();            
            if (Directory.Exists(Application.StartupPath + @"\language"))
            {                
                List<string> ty = new List<string>(Directory.GetFiles(Application.StartupPath + @"\language", "*.xml"));
                foreach (string s in ty)
                {
                    try
                    {
                        XmlSerializer ser = new XmlSerializer(typeof(LanguageFontMaker));
                        TextReader reader = new StreamReader(s);
                        LanguageFontMaker Fields = ser.Deserialize(reader) as LanguageFontMaker;
                        reader.Close();
                        if ((Fields.Language != null) && (Fields.Language != string.Empty))
                        {
                            result.Add(Fields.Language);
                            if (Fields.Default) Default = Fields.Language;
                        }
                    }
                    catch
                    {
                    }
                }
            }
            return result;
        }
        public static void Write(LanguageFontMaker lng)
        {
            try
            {
                if (FileName == string.Empty) return;
                if (!Directory.Exists(Application.StartupPath + @"\language"))
                    Directory.CreateDirectory(Application.StartupPath + @"\language");
                XmlSerializer ser = new XmlSerializer(typeof(LanguageFontMaker));
                TextWriter writer = new StreamWriter(FileName);
                ser.Serialize(writer, lng);
                writer.Close();
            }
            catch
            {
                MessageBox.Show("Cannot write file lang.", "Error");
            }
        }
    }
}